de.caff.generics

## Class RefValueHashMap<K,V>

- java.lang.Object
- - de.caff.generics.RefValueHashMap<K,V>

- All Implemented Interfaces:
    java.util.Map<K,V>
  Direct Known Subclasses:
    SoftValueHashMap, WeakValueHashMap

      public class RefValueHashMap<K,V>
      extends java.lang.Object
      implements java.util.Map<K,V>

  A hashmap with strong keys and soft referenced values. According to the Java specification the references to the weak values are removed on garbage collection if there is no more memory available. See also `WeakValueHashMap` for a hash map with weak referenced values.

  The behavior of this hashmap is that it is possible that a value is `null` because of garbage collection although `containsKey(Object)` says that the associated key is defined. It is able to handle `null` keys and `null` values.

  The default constructors enable auto cleaning, which will automatically remove all dead values each time a dead value is detected, but there are also constructors accepting a boolean autoClean parameter which allow to switch this feature off.

  Some invariances usually true for maps hold not here:

  - Even when the map is not changed in between, subsequent calls to `containsValue(Object)` may return different results.
  - When auto cleaning is switched on, the same is true for calls to `containsKey(Object)`.
  - When auto cleaning is switched on, the entries in the returned set of `keySet()` may no longer be keys when used.
  With these restriction the best usage of this map is as a cache for values which can easily be reconstructed. The only methods which should be used without any problems are the `put(Object, Object)`, `putAll(java.util.Map)` and `get(Object)` methods, when expecting a `null` return on the latter even if a value was added before.
  Author:
    Rammi
  See Also:
    `SoftValueHashMap`, `WeakValueHashMap`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K,V>`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RefValueHashMap(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator)` Constructs an empty `SoftValueHashMap` with the default initial capacity (16) and the default load factor (0.75).
    `RefValueHashMap(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, boolean autoClean)` Constructs an empty `SoftValueHashMap` with the default initial capacity (16) and the default load factor (0.75).
    `RefValueHashMap(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, boolean autoClean, int initialCapacity)` Constructs an empty `SoftValueHashMap` with the specified initial capacity and the default load factor (0.75).
    `RefValueHashMap(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, boolean autoClean, int initialCapacity, float loadFactor)` Constructs an empty `HashMap` with the specified initial capacity and load factor.
    `RefValueHashMap(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, boolean autoClean, java.util.Map<? extends K,? extends V> m)` Constructs a new `HashMap` with the same mappings as the specified `Map`.
    `RefValueHashMap(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, int initialCapacity)` Constructs an empty `SoftValueHashMap` with the specified initial capacity and the default load factor (0.75).
    `RefValueHashMap(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, int initialCapacity, float loadFactor)` Constructs an empty `HashMap` with the specified initial capacity and load factor.
    `RefValueHashMap(ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator, java.util.Map<? extends K,? extends V> m)` Constructs a new `HashMap` with the same mappings as the specified `Map`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Removes all mappings from this map (optional operation).
    `boolean` | `containsKey(java.lang.Object key)` Returns `true` if this map contains a mapping for the specified key.
    `boolean` | `containsValue(java.lang.Object value)` Returns `true` if this map maps one or more keys to the specified value.
    `java.util.Set<java.util.Map.Entry<K,V>>` | `entrySet()` Returns a set view of the mappings contained in this map.
    `V` | `get(java.lang.Object key)` Returns the value to which this map maps the specified key.
    `boolean` | `hasDeadValue(K key)` Return whether the value for a given key was garbage collected.
    `boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
    `java.util.Set<K>` | `keySet()` Returns a set view of the keys contained in this map.
    `V` | `put(K key, V value)` Associates the specified value with the specified key in this map (optional operation).
    `void` | `putAll(java.util.Map<? extends K,? extends V> t)` Copies all of the mappings from the specified map to this map (optional operation).
    `V` | `remove(java.lang.Object key)` Removes the mapping for this key from this map if it is present (optional operation).
    `void` | `removeDeadValues()` Remove all entries from this map which have dead values.
    `int` | `size()` Returns the number of key-value mappings in this map.
    `java.util.Collection<V>` | `values()` Returns a collection view of the values contained in this map.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, equals, forEach, getOrDefault, hashCode, merge, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Constructor Detail

    - #### RefValueHashMap

          public RefValueHashMap(@NotNull
                                 ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator)

      Constructs an empty `SoftValueHashMap` with the default initial capacity (16) and the default load factor (0.75).
      Parameters:
        `creator` - reference creator

    - #### RefValueHashMap

          public RefValueHashMap(@NotNull
                                 ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                 int initialCapacity)

      Constructs an empty `SoftValueHashMap` with the specified initial capacity and the default load factor (0.75).
      Parameters:
        `creator` - reference creator
        `initialCapacity` - the initial capacity.
      Throws:
        `java.lang.IllegalArgumentException` - if the initial capacity is negative.

    - #### RefValueHashMap

          public RefValueHashMap(@NotNull
                                 ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                 int initialCapacity,
                                 float loadFactor)

      Constructs an empty `HashMap` with the specified initial capacity and load factor.
      Parameters:
        `creator` - reference creator
        `initialCapacity` - The initial capacity.
        `loadFactor` - The load factor.
      Throws:
        `java.lang.IllegalArgumentException` - if the initial capacity is negative or the load factor is nonpositive.

    - #### RefValueHashMap

          public RefValueHashMap(@NotNull
                                 ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                 @NotNull
                                 java.util.Map<? extends K,? extends V> m)

      Constructs a new `HashMap` with the same mappings as the specified `Map`. The `HashMap` is created with default load factor (0.75) and an initial capacity sufficient to hold the mappings in the specified `Map`.
      Parameters:
        `creator` - reference creator
        `m` - the map whose mappings are to be placed in this map.
      Throws:
        `java.lang.NullPointerException` - if the specified map is null.

    - #### RefValueHashMap

          public RefValueHashMap(@NotNull
                                 ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                 boolean autoClean)

      Constructs an empty `SoftValueHashMap` with the default initial capacity (16) and the default load factor (0.75).
      Parameters:
        `creator` - reference creator
        `autoClean` - if `true` call `removeDeadValues()` when finding a dead value

    - #### RefValueHashMap

          public RefValueHashMap(@NotNull
                                 ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                 boolean autoClean,
                                 int initialCapacity)

      Constructs an empty `SoftValueHashMap` with the specified initial capacity and the default load factor (0.75).
      Parameters:
        `creator` - reference creator
        `autoClean` - if `true` call `removeDeadValues()` when finding a dead value
        `initialCapacity` - the initial capacity.
      Throws:
        `java.lang.IllegalArgumentException` - if the initial capacity is negative.

    - #### RefValueHashMap

          public RefValueHashMap(@NotNull
                                 ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                 boolean autoClean,
                                 int initialCapacity,
                                 float loadFactor)

      Constructs an empty `HashMap` with the specified initial capacity and load factor.
      Parameters:
        `creator` - reference creator
        `autoClean` - if `true` call `removeDeadValues()` when finding a dead value
        `initialCapacity` - The initial capacity.
        `loadFactor` - The load factor.
      Throws:
        `java.lang.IllegalArgumentException` - if the initial capacity is negative or the load factor is nonpositive.

    - #### RefValueHashMap

          public RefValueHashMap(@NotNull
                                 ReferenceCreator<? extends java.lang.ref.Reference<V>,V> creator,
                                 boolean autoClean,
                                 @NotNull
                                 java.util.Map<? extends K,? extends V> m)

      Constructs a new `HashMap` with the same mappings as the specified `Map`. The `HashMap` is created with default load factor (0.75) and an initial capacity sufficient to hold the mappings in the specified `Map`.
      Parameters:
        `creator` - reference creator
        `autoClean` - if `true` call `removeDeadValues()` when finding a dead value
        `m` - the map whose mappings are to be placed in this map.
      Throws:
        `java.lang.NullPointerException` - if the specified map is null.

  - ### Method Detail

    - #### size

          public int size()

      Returns the number of key-value mappings in this map. If the map contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.
      Specified by:
        `size` in interface `java.util.Map<K,V>`
      Returns:
        the number of key-value mappings in this map.

    - #### isEmpty

          public boolean isEmpty()

      Returns `true` if this map contains no key-value mappings.
      Specified by:
        `isEmpty` in interface `java.util.Map<K,V>`
      Returns:
        `true` if this map contains no key-value mappings.

    - #### containsKey

          public boolean containsKey(java.lang.Object key)

      Returns `true` if this map contains a mapping for the specified key. More formally, returns `true` if and only if this map contains a mapping for a key `k` such that `(key==null ? k==null : key.equals(k))`. (There can be at most one such mapping.)
      Specified by:
        `containsKey` in interface `java.util.Map<K,V>`
      Parameters:
        `key` - key whose presence in this map is to be tested.
      Returns:
        `true` if this map contains a mapping for the specified key.
      Throws:
        `java.lang.ClassCastException` - if the key is of an inappropriate type for this map (optional).
        `java.lang.NullPointerException` - if the key is `null` and this map does not permit `null` keys (optional).

    - #### containsValue

          public boolean containsValue(java.lang.Object value)

      Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `(value==null ? v==null : value.equals(v))`. This operation will probably require time linear in the map size for most implementations of the `Map` interface.
      Specified by:
        `containsValue` in interface `java.util.Map<K,V>`
      Parameters:
        `value` - value whose presence in this map is to be tested.
      Returns:
        `true` if this map maps one or more keys to the specified value.
      Throws:
        `java.lang.ClassCastException` - if the value is of an inappropriate type for this map (optional).
        `java.lang.NullPointerException` - if the value is `null` and this map does not permit `null` values (optional).

    - #### get

          public V get(java.lang.Object key)

      Returns the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.

      More formally, if this map contains a mapping from a key `k` to a value `v` such that `(key==null ? k==null : key.equals(k))`, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.)

      Specified by:
        `get` in interface `java.util.Map<K,V>`
      Parameters:
        `key` - key whose associated value is to be returned.
      Returns:
        the value to which this map maps the specified key, or `null` if the map contains no mapping for this key.
      Throws:
        `java.lang.ClassCastException` - if the key is of an inappropriate type for this map (optional).
        `java.lang.NullPointerException` - if the key is `null` and this map does not permit `null` keys (optional).
      See Also:
        `containsKey(Object)`

    - #### put

          public V put(K key,
                       V value)

      Associates the specified value with the specified key in this map (optional operation). If the map previously contained a mapping for this key, the old value is replaced by the specified value. (A map `m` is said to contain a mapping for a key `k` if and only if `m.containsKey(k)` would return `true`.))
      Specified by:
        `put` in interface `java.util.Map<K,V>`
      Parameters:
        `key` - key with which the specified value is to be associated.
        `value` - value to be associated with the specified key.
      Returns:
        previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key, if the implementation supports `null` values.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `put` operation is not supported by this map.
        `java.lang.ClassCastException` - if the class of the specified key or value prevents it from being stored in this map.
        `java.lang.IllegalArgumentException` - if some aspect of this key or value prevents it from being stored in this map.
        `java.lang.NullPointerException` - if this map does not permit `null` keys or values, and the specified key or value is `null`.

    - #### remove

          public V remove(java.lang.Object key)

      Removes the mapping for this key from this map if it is present (optional operation). More formally, if this map contains a mapping from key `k` to value `v` such that `(key==null ? k==null : key.equals(k))`, that mapping is removed. (The map can contain at most one such mapping.)

      Returns the value to which the map previously associated the key, or `null` if the map contained no mapping for this key. (A `null` return can also indicate that the map previously associated `null` with the specified key if the implementation supports `null` values.) The map will not contain a mapping for the specified key once the call returns.

      Specified by:
        `remove` in interface `java.util.Map<K,V>`
      Parameters:
        `key` - key whose mapping is to be removed from the map.
      Returns:
        previous value associated with specified key, or `null` if there was no mapping for key.
      Throws:
        `java.lang.ClassCastException` - if the key is of an inappropriate type for this map (optional).
        `java.lang.NullPointerException` - if the key is `null` and this map does not permit `null` keys (optional).
        `java.lang.UnsupportedOperationException` - if the `remove` method is not supported by this map.

    - #### putAll

          public void putAll(@NotNull
                             java.util.Map<? extends K,? extends V> t)

      Copies all of the mappings from the specified map to this map (optional operation). The effect of this call is equivalent to that of calling `put(k, v)` on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is unspecified if the specified map is modified while the operation is in progress.
      Specified by:
        `putAll` in interface `java.util.Map<K,V>`
      Parameters:
        `t` - Mappings to be stored in this map.
      Throws:
        `java.lang.UnsupportedOperationException` - if the `putAll` method is not supported by this map.
        `java.lang.ClassCastException` - if the class of a key or value in the specified map prevents it from being stored in this map.
        `java.lang.IllegalArgumentException` - some aspect of a key or value in the specified map prevents it from being stored in this map.
        `java.lang.NullPointerException` - if the specified map is `null`, or if this map does not permit `null` keys or values, and the specified map contains `null` keys or values.

    - #### clear

          public void clear()

      Removes all mappings from this map (optional operation).
      Specified by:
        `clear` in interface `java.util.Map<K,V>`
      Throws:
        `java.lang.UnsupportedOperationException` - clear is not supported by this map.

    - #### keySet

          @NotNull
          public java.util.Set<K> keySet()

      Returns a set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll` `retainAll`, and `clear` operations. It does not support the add or `addAll` operations.
      Specified by:
        `keySet` in interface `java.util.Map<K,V>`
      Returns:
        a set view of the keys contained in this map.

    - #### values

          @NotNull
          public java.util.Collection<V> values()

      Returns a collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. If the map is modified while an iteration over the collection is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the add or `addAll` operations.
      Specified by:
        `values` in interface `java.util.Map<K,V>`
      Returns:
        a collection view of the values contained in this map.

    - #### entrySet

          @NotNull
          public java.util.Set<java.util.Map.Entry<K,V>> entrySet()

      Returns a set view of the mappings contained in this map. Each element in the returned set is a `Map.Entry`. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation, or through the `setValue` operation on a map entry returned by the iterator) the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `entrySet` in interface `java.util.Map<K,V>`
      Returns:
        a set view of the mappings contained in this map.

    - #### hasDeadValue

          public boolean hasDeadValue(@NotNull
                                      K key)

      Return whether the value for a given key was garbage collected.
      Parameters:
        `key` - key to look for
      Returns:
        `true` the value was garbage collected and is no longer available,
        `false` the value is still available (but may be gone soon)

    - #### removeDeadValues

          public void removeDeadValues()

      Remove all entries from this map which have dead values.